import rivet

def doexit(msg):
	print msg
	import sys
	sys.exit()

t=rivet.init()

b=t.button('-text', 'test simple callback invocation')
b.pack()
def test1():
	print 'callback successfully invoked'
b.bind('<1>', test1)

#

c=t.button('-text', 'test passing a argument to callback')
c.pack()
def test2(arg1):
	print 'callback successful with arg = ', arg1
c.bind('<1>', (test2, 'hi there'))

#

d=t.button('-text', 'test getting info about event')
d.pack()
def test3(xpos):
	print 'callback successful with x = ', xpos
d.bind('<1>', (test3, '%x'))

#

e=t.button('-text', 'test multiple callbacks for one bind spec')
e.pack()
def test4a():
	print 'callback 1 successful'
def test4b():
	print 'callback 2 successful'
e.bind('<1>', test4a)
e.bind('<1>', test4b, 1)
if(e.bind() != '<Button-1>'):
	doexit('test 4c failed')

#

def test5():
	print 'command callback successful - 1'
f=t.button('-text', 'test command, style 1', '-command', test5)
f.pack()

def test6(arg1):
	print arg1
g=t.button('-text', 'test command, style 2',
	'-command', (test6, 'command callback successful - 2'))
g.pack()

#

h=t.button('-text', 'removed callback - nothing should be invoked')
h.pack()
def test6():
	print 'this callback should not be invoked'
h.bind('<1>', test6)
if(h.bind('<1>') != (test6,)):
	doexit('test 6 failed!')
h.bind('<1>', None)

#

z=t.button('-text', 'Quit')
z.pack()
z.bind('<1>', (doexit, 'goodbye'))

if __name__ == '__main__':
	rivet.mainloop()

