import rivet
import os


infd, outfd = os.pipe()
testdata = 'somedatatoread'
gotdata = None

def reader():
	global gotdata
	data = os.read(infd, 1000)
	if data != testdata:
		print "you shouldn't see this message"
	gotdata = 1

def writer():
	os.write(outfd, testdata)

def test():
	rivet.init()
	rivet.fileevent(infd, 'readable', reader)
	if rivet.fileevent(infd, 'readable') != reader:
		print 'getting the callback did not work as it should have.'

	writer()
	rivet.update()
	if gotdata:
		print 'test successful'
	else:
		print 'never read data as expected'

test()

