import rivet, rivetutil
import sys

var=rivetutil.intvar()
checkvar1=rivetutil.stringvar()
checkvar2=rivetutil.stringvar()

def radiotest(top):
	b=top.radiobutton(text='Radio Button 1',
			variable=var,
			value=1)
	c=top.radiobutton(text='Radio Button 2',
			variable=var,
			value=2)
	d=top.radiobutton(text='Radio Button 3',
			variable=var,
			value=3)
	rivet.pack(b, c, d)
	var.set(1)

def checktest(top):
	b=top.checkbutton(text='Check Button 1',
			variable=checkvar1,
			onvalue='on', offvalue='off')
	c=top.checkbutton(text='Check Button 2',
			variable=checkvar2,
			onvalue='on', offvalue='off')
	b.pack(c)

def status(top):
	def report():
		print 'The Radio Buttons have value:', var.get()
		print 'Check button 1 is:', checkvar1.get()
		print 'Check button 2 is:', checkvar2.get()

	b=top.button(text='status', command=report)
	b.pack()


def quitbutton(top):
	b=top.button(text='quit', command=sys.exit)
	b.pack()
	return b

def run():
	top = rivet.init()
	radiotest(top)
	checktest(top)
	status(top)
	quitbutton(top)
	rivet.mainloop()

if __name__ == '__main__':
	run()

