import rivet

def timercallback(msg, repeat):
	print msg
	if repeat:
		rivet.after(repeat, (timercallback, msg, repeat))

def test1():
	rivet.after(1000, (timercallback, 'one second, once', 0))
	rivet.after(1000, (timercallback, 'one second, repeating', 1000))
	timer1 = rivet.after(1000, (timercallback, 'this should never get printed', 100))
	timer1.cancel()

	rivet.after('idle', (timercallback, 'Idle callback', 0))
	timer2 = rivet.after('idle', (timercallback, 'this should never get printed', 0))
	timer2.cancel()

def quit():
	import sys
	print 'goodbye'
	sys.exit()

def run():
	t=rivet.init()
	test1()
	b=t.button('-text', 'Quit', '-command', quit)
	b.pack()
	rivet.mainloop()

if __name__ == '__main__':
	run()

