import rivet, rivetutil

# example illustrating using variables and traces

def variable_changed(var, label):
	label.configure('text', var.get())

t = rivet.init()
v = rivetutil.stringvar()
v.set(5)
s = rivet.scale(t, variable=v)
l = rivet.label(t, textvariable=v)	# let tk do this automatically
l2 = rivet.label(t, text=v.get())	# do this one by hand
v.trace('w', (variable_changed, v, l2))

rivet.pack(s, l, l2, side='top', expand=1, fill='both')
rivet.mainloop()

