#include "rivet.h"

/*
 *--------------------------------------------------------------
 * Following code lifted and modified from tcl tclCmdMZ.c
 *--------------------------------------------------------------
 */


#ifdef UNUSED_CODE
char *
rivet_string_index(str1, index)
	char	*str1;
	int	index;
{
	static char buf[2];
	if ((index >= 0) && (index < (int) strlen(str1)))
		buf[0] = str1[index];
	return buf;
}
#endif

int
rivet_wordend(str1, index)
	char           *str1;
	int             index;
{
	int             length, cur;
	char		c;

	length = strlen(str1);
	if (index < 0) {
		index = 0;
	}
	if (index >= length) {
		cur = length;
		goto wordendDone;
	}
	for (cur = index; cur < length; cur++) {
		c = UCHAR(str1[cur]);
		if (!isalnum(c) && (c != '_')) {
			break;
		}
	}
	if (cur == index) {
		cur = index + 1;
	}
wordendDone:
	return cur;
}


int
rivet_wordstart(str1, index)
	char           *str1;
	int             index;
{
	int             length, cur;
	char		c;

	length = strlen(str1);
	if (index >= length) {
		index = length - 1;
	}
	if (index <= 0) {
		cur = 0;
		goto wordstartDone;
	}
	for (cur = index; cur >= 0; cur--) {
		c = UCHAR(str1[cur]);
		if (!isalnum(c) && (c != '_')) {
			break;
		}
	}
	if (cur != index) {
		cur += 1;
	}
wordstartDone:
	return cur;
}
